5 # Never run this makefile in parallel, as it could screw things up
6 # It won't affect the submakes, so you still get the speedup from specifying -jx
9 # Allow the silent with lower caps to work the same way as upper caps
15 SUB_IS_SILENT := $(SILENT)
18 # We need to make sure that silent is always turned off at the top level
19 # Otherwise the [OK], [ERROR] and [WARN] messages won't be displayed correctly
20 override SILENT := false
24 QMK_VERSION := $(shell git describe --abbrev=0 --tags 2>/dev/null)
27 ifneq ($(QMK_VERSION),)
28 $(info QMK Firmware $(QMK_VERSION))
32 ON_ERROR := error_occurred=1
36 STARTING_MAKEFILE := $(firstword $(MAKEFILE_LIST))
37 ROOT_MAKEFILE := $(lastword $(MAKEFILE_LIST))
38 ROOT_DIR := $(dir $(ROOT_MAKEFILE))
42 ABS_STARTING_MAKEFILE := $(abspath $(STARTING_MAKEFILE))
43 ABS_ROOT_MAKEFILE := $(abspath $(ROOT_MAKEFILE))
44 ABS_STARTING_DIR := $(dir $(ABS_STARTING_MAKEFILE))
45 ABS_ROOT_DIR := $(dir $(ABS_ROOT_MAKEFILE))
46 STARTING_DIR := $(subst $(ABS_ROOT_DIR),,$(ABS_STARTING_DIR))
47 BUILD_DIR := $(ROOT_DIR)/.build
48 TEST_DIR := $(BUILD_DIR)/test
49 ERROR_FILE := $(BUILD_DIR)/error_occurred
53 # Helper function to process the newt element of a space separated path
54 # It works a bit like the traditional functional head tail
55 # so the CURRENT_PATH_ELEMENT will become the new head
56 # and the PATH_ELEMENTS are the rest that are still unprocessed
57 define NEXT_PATH_ELEMENT
58 $$(eval CURRENT_PATH_ELEMENT := $$(firstword $$(PATH_ELEMENTS)))
59 $$(eval PATH_ELEMENTS := $$(wordlist 2,9999,$$(PATH_ELEMENTS)))
62 # We change the / to spaces so that we more easily can work with the elements
64 PATH_ELEMENTS := $(subst /, ,$(STARTING_DIR))
65 # Initialize the path elements list for further processing
66 $(eval $(call NEXT_PATH_ELEMENT))
68 # This function sets the KEYBOARD; KEYMAP and SUBPROJECT to the correct
69 # variables depending on which directory you stand in.
70 # It's really a very simple if else chain, if you squint enough,
71 # but the makefile syntax makes it very verbose.
72 # If we are in a subfolder of keyboards
74 # *** No longer needed **
76 # ifeq ($(CURRENT_PATH_ELEMENT),keyboards)
77 # $(eval $(call NEXT_PATH_ELEMENT))
78 # KEYBOARD := $(CURRENT_PATH_ELEMENT)
79 # $(eval $(call NEXT_PATH_ELEMENT))
80 # # If we are in a subfolder of keymaps, or in other words in a keymap
82 # ifeq ($(CURRENT_PATH_ELEMENT),keymaps)
83 # $(eval $(call NEXT_PATH_ELEMENT))
84 # KEYMAP := $(CURRENT_PATH_ELEMENT)
85 # # else if we are not in the keyboard folder itself
86 # else ifneq ($(CURRENT_PATH_ELEMENT),)
87 # # the we can assume it's a subproject, as no other folders
88 # # should have make files in them
89 # SUBPROJECT := $(CURRENT_PATH_ELEMENT)
90 # $(eval $(call NEXT_PATH_ELEMENT))
91 # # if we are inside a keymap folder of a subproject
92 # ifeq ($(CURRENT_PATH_ELEMENT),keymaps)
93 # $(eval $(call NEXT_PATH_ELEMENT))
94 # KEYMAP := $(CURRENT_PATH_ELEMENT)
100 ifndef ALT_GET_KEYBOARDS
101 All_RULES_MK := $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/rules.mk))
102 All_RULES_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/rules.mk))
103 All_RULES_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/rules.mk))
104 All_RULES_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/*/rules.mk))
106 KEYMAPS_MK := $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/keymaps/*/rules.mk))
107 KEYMAPS_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/keymaps/*/rules.mk))
108 KEYMAPS_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/keymaps/*/rules.mk))
109 KEYMAPS_MK += $$(patsubst $(ROOT_DIR)/keyboards/%/rules.mk,%,$$(wildcard $(ROOT_DIR)/keyboards/*/*/*/*/keymaps/*/rules.mk))
111 KEYBOARDS := $$(sort $$(filter-out $$(KEYMAPS_MK), $$(All_RULES_MK)))
113 KEYBOARDS := $(shell find keyboards/ -type f -iname "rules.mk" | grep -v keymaps | sed 's!keyboards/\(.*\)/rules.mk!\1!' | sort | uniq)
117 $(eval $(call GET_KEYBOARDS))
119 # Only consider folders with makefiles, to prevent errors in case there are extra folders
120 #KEYBOARDS += $(patsubst $(ROOD_DIR)/keyboards/%/rules.mk,%,$(wildcard $(ROOT_DIR)/keyboards/*/*/rules.mk))
122 .PHONY: list-keyboards
126 define PRINT_KEYBOARD
127 $(info $(PRINTING_KEYBOARD))
130 .PHONY: generate-keyboards-file
131 generate-keyboards-file:
132 $(foreach PRINTING_KEYBOARD,$(KEYBOARDS),$(eval $(call PRINT_KEYBOARD)))
136 echo -n 'Deleting .build/ ... '
142 echo -n 'Deleting *.bin and *.hex ... '
146 #Compatibility with the old make variables, anything you specify directly on the command line
147 # always overrides the detected folders
149 KEYBOARD := $(keyboard)
155 # Uncomment these for debugging
156 # $(info Keyboard: $(KEYBOARD))
157 # $(info Keymap: $(KEYMAP))
158 # $(info Subproject: $(SUBPROJECT))
159 # $(info Keyboards: $(KEYBOARDS))
162 # Set the default goal depending on where we are running make from
163 # this handles the case where you run make without any arguments
164 .DEFAULT_GOAL := all:all
166 .DEFAULT_GOAL := $(KEYBOARD):$(KEYMAP)
167 else ifneq ($(KEYBOARD),)
168 # Inside a keyboard folder, build all keymaps for all subprojects
169 # Note that this is different from the old behaviour, which would
170 # build only the default keymap of the default keyboard
171 .DEFAULT_GOAL := $(KEYBOARD):all
175 # Compare the start of the RULE variable with the first argument($1)
176 # If the rules equals $1 or starts with $1:, RULE_FOUND is set to true
177 # and $1 is removed from the RULE variable
178 # Otherwise the RULE_FOUND variable is set to false, and RULE left as it was
179 # The function is a bit tricky, since there's no built in $(startswith) function
180 define COMPARE_AND_REMOVE_FROM_RULE_HELPER
185 STARTCOLON_REMOVED=$$(subst START$1:,,START$$(RULE))
186 ifneq ($$(STARTCOLON_REMOVED),START$$(RULE))
188 RULE := $$(STARTCOLON_REMOVED)
195 # This makes it easier to call COMPARE_AND_REMOVE_FROM_RULE, since it makes it behave like
196 # a function that returns the value
197 COMPARE_AND_REMOVE_FROM_RULE = $(eval $(call COMPARE_AND_REMOVE_FROM_RULE_HELPER,$1))$(RULE_FOUND)
200 # Recursively try to find a match for the start of the rule to be checked
201 # $1 The list to be checked
202 # If a match is found, then RULE_FOUND is set to true
203 # and MATCHED_ITEM to the item that was matched
204 define TRY_TO_MATCH_RULE_FROM_LIST_HELPER3
206 ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,$$(firstword $1)),true)
207 MATCHED_ITEM := $$(firstword $1)
209 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER3,$$(wordlist 2,9999,$1)))
214 # A recursive helper function for finding the longest match
215 # $1 The list to be checked
216 # It works by always removing the currently matched item from the list
217 # and call itself recursively, until a match is found
218 define TRY_TO_MATCH_RULE_FROM_LIST_HELPER2
219 # Stop the recursion when the list is empty
221 RULE_BEFORE := $$(RULE)
222 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER3,$1))
223 # If a match is found in the current list, otherwise just return what we had before
224 ifeq ($$(RULE_FOUND),true)
225 # Save the best match so far and call itself recursively
226 BEST_MATCH := $$(MATCHED_ITEM)
227 BEST_MATCH_RULE := $$(RULE)
229 RULE := $$(RULE_BEFORE)
230 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER2,$$(filter-out $$(MATCHED_ITEM),$1)))
236 # Recursively try to find the longest match for the start of the rule to be checked
237 # $1 The list to be checked
238 # If a match is found, then RULE_FOUND is set to true
239 # and MATCHED_ITEM to the item that was matched
240 define TRY_TO_MATCH_RULE_FROM_LIST_HELPER
242 $$(eval $$(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER2,$1))
243 ifneq ($$(BEST_MATCH),)
245 RULE := $$(BEST_MATCH_RULE)
246 MATCHED_ITEM := $$(BEST_MATCH)
253 # Make it easier to call TRY_TO_MATCH_RULE_FROM_LIST
254 TRY_TO_MATCH_RULE_FROM_LIST = $(eval $(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER,$1))$(RULE_FOUND)
256 define ALL_IN_LIST_LOOP
257 OLD_RULE$1 := $$(RULE)
258 $$(eval $$(call $1,$$(ITEM$1)))
259 RULE := $$(OLD_RULE$1)
262 define PARSE_ALL_IN_LIST
263 $$(foreach ITEM$1,$2,$$(eval $$(call ALL_IN_LIST_LOOP,$1)))
266 # The entry point for rule parsing
267 # parses a rule in the format <keyboard>:<keymap>:<target>
268 # but this particular function only deals with the first <keyboard> part
272 # If the rule starts with all, then continue the parsing from
273 # PARSE_ALL_KEYBOARDS
274 ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
275 $$(eval $$(call PARSE_ALL_KEYBOARDS))
276 else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,test),true)
277 $$(eval $$(call PARSE_TEST))
278 # If the rule starts with the name of a known keyboard, then continue
279 # the parsing from PARSE_KEYBOARD
280 else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(KEYBOARDS)),true)
281 $$(eval $$(call PARSE_KEYBOARD,$$(MATCHED_ITEM)))
282 # Otherwise use the KEYBOARD variable, which is determined either by
283 # the current directory you run make from, or passed in as an argument
284 else ifneq ($$(KEYBOARD),)
285 $$(eval $$(call PARSE_KEYBOARD,$$(KEYBOARD)))
287 $$(info make: *** No rule to make target '$1'. Stop.)
289 $$(info | QMK's make format recently changed to use folder locations and colons:)
290 $$(info | make project_folder:keymap[:target])
292 $$(info | make planck/rev4:default:dfu)
293 $$(info | make planck:default)
299 # Parses a rule in the format <keymap>:<target>
300 # the keyboard is already known when entering this function
301 define PARSE_KEYBOARD
302 # If we want to compile the default subproject, then we need to
303 # include the correct makefile to determine the actual name of it
306 # KEYBOARD_FOLDERS := $$(subst /, , $(CURRENT_KB))
308 DEFAULT_FOLDER := $$(CURRENT_KB)
310 # We assume that every rules.mk will contain the full default value
311 $$(eval include $(ROOT_DIR)/keyboards/$$(CURRENT_KB)/rules.mk)
312 ifneq ($$(DEFAULT_FOLDER),$$(CURRENT_KB))
313 $$(eval include $(ROOT_DIR)/keyboards/$$(DEFAULT_FOLDER)/rules.mk)
315 CURRENT_KB := $$(DEFAULT_FOLDER)
318 KEYBOARD_FOLDER_PATH_1 := $$(CURRENT_KB)
319 KEYBOARD_FOLDER_PATH_2 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_1)))
320 KEYBOARD_FOLDER_PATH_3 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_2)))
321 KEYBOARD_FOLDER_PATH_4 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_3)))
322 KEYBOARD_FOLDER_PATH_5 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_4)))
325 # get a list of all keymaps
326 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/keymaps/*/.)))
327 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/keymaps/*/.)))
328 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/keymaps/*/.)))
329 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/keymaps/*/.)))
330 KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/keymaps/*/.)))
331 # this might be needed, but in a different form
332 #KEYMAPS := $$(sort $$(filter-out $$(KEYBOARD_FOLDER_1) $$(KEYBOARD_FOLDER_2) \
333 $$(KEYBOARD_FOLDER_3) $$(KEYBOARD_FOLDER_4) $$(KEYBOARD_FOLDER_5), $$(KEYMAPS)))
336 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/rules.mk)","")
338 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/rules.mk)
339 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
341 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/rules.mk)","")
343 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/rules.mk)
344 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
346 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/rules.mk)","")
348 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/rules.mk)
349 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
351 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/rules.mk)","")
353 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/rules.mk)
354 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
356 ifneq ("$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/rules.mk)","")
358 $$(eval include $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/rules.mk)
359 KEYBOARD_LAYOUTS := $$(sort $$(LAYOUTS) $$(KEYBOARD_LAYOUTS))
363 $$(foreach LAYOUT,$$(KEYBOARD_LAYOUTS),$$(eval LAYOUT_KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/layouts/*/$$(LAYOUT)/*/.)))))
365 KEYMAPS := $$(sort $$(KEYMAPS) $$(LAYOUT_KEYMAPS))
367 # if the rule after removing the start of it is empty (we haven't specified a kemap or target)
368 # compile all the keymaps
370 $$(eval $$(call PARSE_ALL_KEYMAPS))
371 # The same if all was specified
372 else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
373 $$(eval $$(call PARSE_ALL_KEYMAPS))
374 # Try to match the specified keyamp with the list of known keymaps
375 else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(KEYMAPS)),true)
376 $$(eval $$(call PARSE_KEYMAP,$$(MATCHED_ITEM)))
377 # Otherwise try to match the keymap from the current folder, or arguments to the make command
378 else ifneq ($$(KEYMAP),)
379 $$(eval $$(call PARSE_KEYMAP,$$(KEYMAP)))
380 # Otherwise, make all keymaps, again this is consistent with how it works without
383 $$(eval $$(call PARSE_ALL_KEYMAPS))
387 # if we are going to compile all keyboards, match the rest of the rule
389 define PARSE_ALL_KEYBOARDS
390 $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYBOARD,$(KEYBOARDS)))
394 # When entering this, the keyboard and subproject are known, so now we need
395 # to determine which keymaps are going to get compiled
396 # define PARSE_SUBPROJECT
400 # If we want to parse all subprojects, but the keyboard doesn't have any,
401 # then use defaultsp instead
402 # define PARSE_ALL_SUBPROJECTS
403 # ifeq ($$(SUBPROJECTS),)
404 # $$(eval $$(call PARSE_SUBPROJECT,defaultsp))
406 # $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_SUBPROJECT,$$(SUBPROJECTS)))
411 # This is the meat of compiling a keyboard, when entering this, everything is known
412 # keyboard, subproject, and keymap
413 # Note that we are not directly calling the command here, but instead building a list,
414 # which will later be processed
417 # The rest of the rule is the target
418 # Remove the leading ":" from the target, as it acts as a separator
419 MAKE_TARGET := $$(patsubst :%,%,$$(RULE))
420 # We need to generate an unique indentifer to append to the COMMANDS list
421 CURRENT_KB_UNDER := $$(subst /,_,$$(CURRENT_KB))
422 COMMAND := COMMAND_KEYBOARD_$$(CURRENT_KB_UNDER)_KEYMAP_$$(CURRENT_KM)
423 # If we are compiling a keyboard without a subproject, we want to display just the name
424 # of the keyboard, otherwise keyboard/subproject
425 KB_SP := $$(CURRENT_KB)
427 KB_SP := $(BOLD)$$(KB_SP)$(NO_COLOR)
428 # Specify the variables that we are passing forward to submake
429 MAKE_VARS := KEYBOARD=$$(CURRENT_KB) KEYMAP=$$(CURRENT_KM)
430 # And the first part of the make command
431 MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f build_keyboard.mk $$(MAKE_TARGET)
432 # The message to display
433 MAKE_MSG := $$(MSG_MAKE_KB)
434 # We run the command differently, depending on if we want more output or not
435 # The true version for silent output and the false version otherwise
436 $$(eval $$(call BUILD))
440 MAKE_VARS += VERBOSE=$(VERBOSE) COLOR=$(COLOR)
441 COMMANDS += $$(COMMAND)
442 COMMAND_true_$$(COMMAND) := \
443 printf "$$(MAKE_MSG)" | \
444 $$(MAKE_MSG_FORMAT); \
445 LOG=$$$$($$(MAKE_CMD) $$(MAKE_VARS) SILENT=true 2>&1) ; \
446 if [ $$$$? -gt 0 ]; \
447 then $$(PRINT_ERROR_PLAIN); \
448 elif [ "$$$$LOG" != "" ] ; \
449 then $$(PRINT_WARNING_PLAIN); \
453 COMMAND_false_$$(COMMAND) := \
454 printf "$$(MAKE_MSG)\n\n"; \
455 $$(MAKE_CMD) $$(MAKE_VARS) SILENT=false; \
456 if [ $$$$? -gt 0 ]; \
457 then error_occurred=1; \
461 # Just parse all the keymaps for a specific keyboard
462 define PARSE_ALL_KEYMAPS
463 $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYMAP,$$(KEYMAPS)))
470 MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f build_test.mk $$(MAKE_TARGET)
471 MAKE_VARS := TEST=$$(TEST_NAME) FULL_TESTS="$$(FULL_TESTS)"
472 MAKE_MSG := $$(MSG_MAKE_TEST)
473 $$(eval $$(call BUILD))
474 ifneq ($$(MAKE_TARGET),clean)
475 TEST_EXECUTABLE := $$(TEST_DIR)/$$(TEST_NAME).elf
476 TESTS += $$(TEST_NAME)
477 TEST_MSG := $$(MSG_TEST)
478 $$(TEST_NAME)_COMMAND := \
479 printf "$$(TEST_MSG)\n"; \
480 $$(TEST_EXECUTABLE); \
481 if [ $$$$? -gt 0 ]; \
482 then error_occurred=1; \
490 TEST_NAME := $$(firstword $$(subst :, ,$$(RULE)))
491 TEST_TARGET := $$(subst $$(TEST_NAME),,$$(subst $$(TEST_NAME):,,$$(RULE)))
492 ifeq ($$(TEST_NAME),all)
493 MATCHED_TESTS := $$(TEST_LIST)
495 MATCHED_TESTS := $$(foreach TEST,$$(TEST_LIST),$$(if $$(findstring $$(TEST_NAME),$$(TEST)),$$(TEST),))
497 $$(foreach TEST,$$(MATCHED_TESTS),$$(eval $$(call BUILD_TEST,$$(TEST),$$(TEST_TARGET))))
501 # Set the silent mode depending on if we are trying to compile multiple keyboards or not
502 # By default it's on in that case, but it can be overridden by specifying silent=false
503 # from the command line
504 define SET_SILENT_MODE
506 SILENT_MODE := $(SUB_IS_SILENT)
507 else ifeq ($$(words $$(COMMANDS)),1)
514 include $(ROOT_DIR)/message.mk
516 ifeq ($(strip $(BREAK_ON_ERRORS)), yes)
517 HANDLE_ERROR = exit 1
519 HANDLE_ERROR = echo $$error_occurred > $(ERROR_FILE)
522 # The empty line is important here, as it will force a new shell to be created for each command
523 # Otherwise the command line will become too long with a lot of keyboards and keymaps
526 $(COMMAND_$(SILENT_MODE)_$(COMMAND))\
527 if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
534 if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
539 # Let's match everything, we handle all the rule parsing ourselves
542 # Check if we have the CMP tool installed
543 cmp $(ROOT_DIR)/Makefile $(ROOT_DIR)/Makefile >/dev/null 2>&1; if [ $$? -gt 0 ]; then printf "$(MSG_NO_CMP)"; exit 1; fi;
544 # Ensure that python3 is installed. This check can be removed after python is used in more places.
545 if ! python3 --version 1> /dev/null 2>&1; then printf "$(MSG_PYTHON_MISSING)"; fi
546 # Check if the submodules are dirty, and display a warning if they are
548 if [ ! -e lib/chibios ]; then git submodule sync lib/chibios && git submodule update --depth 1 --init lib/chibios; fi
549 if [ ! -e lib/chibios-contrib ]; then git submodule sync lib/chibios-contrib && git submodule update --depth 1 --init lib/chibios-contrib; fi
550 if [ ! -e lib/ugfx ]; then git submodule sync lib/ugfx && git submodule update --depth 1 --init lib/ugfx; fi
551 if [ ! -e lib/lufa ]; then git submodule sync lib/lufa && git submodule update --depth 1 --init lib/lufa; fi
552 git submodule status --recursive 2>/dev/null | \
553 while IFS= read -r x; do \
556 *) printf "$(MSG_SUBMODULE_DIRTY)";break;; \
560 rm -f $(ERROR_FILE) > /dev/null 2>&1
561 $(eval $(call PARSE_RULE,$@))
562 $(eval $(call SET_SILENT_MODE))
563 # Run all the commands in the same shell, notice the + at the first line
564 # it has to be there to allow parallel execution of the submake
565 # This always tries to compile everything, even if error occurs in the middle
566 # But we return the error code at the end, to trigger travis failures
567 # The sort at this point is to remove duplicates
568 $(foreach COMMAND,$(sort $(COMMANDS)),$(RUN_COMMAND))
569 if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
570 $(foreach TEST,$(sort $(TESTS)),$(RUN_TEST))
571 if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
573 # These no longer work because of the colon system
575 # All should compile everything
577 # all: all-keyboards test-all
579 # Define some shortcuts, mostly for compatibility with the old syntax
580 # .PHONY: all-keyboards
581 # all-keyboards: all\:all\:all
583 # .PHONY: all-keyboards-defaults
584 # all-keyboards-defaults: all\:default
590 # test-clean: test-all-clean
593 git submodule sync $?
594 git submodule update --init $?
596 .PHONY: git-submodule
598 git submodule sync --recursive
599 git submodule update --init --recursive --progress
605 # Generate the version.h file
607 GIT_VERSION := $(shell git describe --abbrev=6 --dirty --always --tags 2>/dev/null || date +"%Y-%m-%d-%H:%M:%S")
612 BUILD_DATE := $(shell date +"%Y-%m-%d-%H:%M:%S")
613 $(shell echo '#define QMK_VERSION "$(GIT_VERSION)"' > $(ROOT_DIR)/quantum/version.h)
614 $(shell echo '#define QMK_BUILDDATE "$(BUILD_DATE)"' >> $(ROOT_DIR)/quantum/version.h)
619 include $(ROOT_DIR)/testlist.mk